try
{
  var rahead = false;
  var tohead = false;
  var cohist = false;
  var asohist = false;
  var qry = toolbox.executeQuery("SELECT EXISTS(SELECT 1 "
                               + "                FROM pg_attribute "
                               + "                JOIN pg_class ON attrelid = pg_class.oid "
                               + "               WHERE relname = 'cohist' "
                               + "                 AND attname = 'cohist_billtocountry' "
                               + "                 AND attnum > 0) AS cohist, "
                               + "       EXISTS(SELECT 1 "
                               + "                FROM pg_attribute "
                               + "                JOIN pg_class ON attrelid = pg_class.oid "
                               + "               WHERE relname = 'asohist' "
                               + "                 AND attname = 'asohist_billtocountry' "
                               + "                 AND attnum > 0) AS asohist, "
                               + "       EXISTS(SELECT 1 "
                               + "                FROM pg_class "
                               + "               WHERE relname = 'rahead' "
                               + "                 AND relkind = 'r') AS rahead, "
                               + "       EXISTS(SELECT 1 "
                               + "                FROM pg_class "
                               + "               WHERE relname = 'tohead' "
                               + "                 AND relkind = 'r') AS tohead;");
  if (qry.first())
  {
    cohist = qry.value("cohist");
    asohist = qry.value("asohist");
    rahead = qry.value("rahead");
    tohead = qry.value("tohead");
  }
  else if (qry.lastError().type != QSqlError.NoError)
    QMessageBox.critical(mywindow, qsTr("Error checking tables"), qry.lastError().text);

  var _menu = mainwindow.findChild("menu.crm.utilities");
  var fixCountriesAction = _menu.addAction(qsTr("Fix Countries"));
  fixCountriesAction.enabled = privileges.value("MaintainAddresses") &&
                               privileges.value("MaintainQuotes") &&
                               privileges.value("MaintainSalesOrders") &&
                               privileges.value("MaintainMiscInvoices") &&
                               privileges.value("MaintainCreditMemos") &&
                               privileges.value("MaintainPurchaseOrders") &&
                               ((!cohist && !asohist) || privileges.value("EditSalesHistory")) &&
                               (!rahead || privileges.value("MaintainReturns")) &&
                               (!tohead || privileges.value("MaintainTransferOrders"));
  fixCountriesAction.triggered.connect(sFixCountries);
}
catch (e)
{
  QMessageBox.critical(mywindow, "initMenu", "initMenu.js exception: " + e);
}

function sFixCountries()
{
  try
  {
    var params = {};
    if (cohist)
      params.cohist = true;
    if (asohist)
      params.asohist = true;
    if (rahead)
      params.rahead = true;
    if (tohead)
      params.tohead = true;

    toolbox.openWindow("fixCountries", 0, Qt.Window, Qt.NonModal);
    toolbox.lastWindow().set(params);
  }
  catch (e)
  {
    QMessageBox.critical(mywindow, "initMenu", "sFixCountries() exception: " + e);
  }
}
